## qtcreator 4.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(FeatureSummary)
include(QtCreatorIDEBranding)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(WITH_TESTS "Build Tests" OFF)
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality (e.g. source file disk checking)" OFF)
option(BUILD_WITH_PCH "Build with precompiled headers" ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt5::Test)
endif()

find_package(Qt5
  COMPONENTS Concurrent Core Gui LinguistTools Network PrintSupport Qml Quick
    QuickWidgets Sql Widgets Xml ${QT_TEST_COMPONENT}
  REQUIRED
)

find_package(Threads)

# Get information on directories from qmake
# as this is not yet exported by cmake.
function(qt5_query_qmake)
  if (NOT TARGET Qt5::qmake)
    message(FATAL_ERROR "Qmake was not found.")
  endif()

  get_target_property(_qmake_binary Qt5::qmake IMPORTED_LOCATION)
  execute_process(COMMAND "${_qmake_binary}" "-query"
                  TIMEOUT 10
                  RESULT_VARIABLE _qmake_result
                  OUTPUT_VARIABLE _qmake_stdout
                  OUTPUT_STRIP_TRAILING_WHITESPACE)

  if (NOT "${_qmake_result}" STREQUAL "0")
    message(FATAL_ERROR "Qmake did not execute successfully: ${_qmake_result}.")
  endif()

  # split into lines:
  string(REPLACE "\n" ";" _lines "${_qmake_stdout}")

  foreach(_line ${_lines})
    # split line into key/value pairs
    string(REPLACE ":" ";" _parts "${_line}")
    list(GET _parts 0 _key)
    list(REMOVE_AT _parts 0)
    string(REPLACE ";" ":" _value "${_parts}")

    set("${_key}" "${_value}" CACHE PATH "qmake import of ${_key}" FORCE)
  endforeach()
endfunction()

qt5_query_qmake()

find_package(Qt5 COMPONENTS Designer Help Script SerialPort Svg QUIET)
function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt5::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

add_library(OptionalSvg INTERFACE)
if (TARGET Qt5::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt5::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

find_package(Clang COMPONENTS libclang QUIET)
find_package(LLVM QUIET)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

include(QtCreatorAPI)

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)

if (WITH_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

=== bin/CMakeLists.txt ===
install(PROGRAMS qtcreator.sh DESTINATION bin)

=== src/CMakeLists.txt ===
add_library(app_version INTERFACE)
target_include_directories(app_version
  INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  INTERFACE $<INSTALL_INTERFACE:include/src>)
install(TARGETS app_version EXPORT QtCreator)

add_subdirectory(libs)
add_subdirectory(share)
add_subdirectory(shared)
add_subdirectory(app)
add_subdirectory(plugins)
add_subdirectory(tools)

install(
  FILES
    ${PROJECT_SOURCE_DIR}/HACKING
    ${PROJECT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT
    ${PROJECT_SOURCE_DIR}/README.md
  DESTINATION ./
  COMPONENT Devel EXCLUDE_FROM_ALL
)

install(
  DIRECTORY
    ${PROJECT_SOURCE_DIR}/doc
    ${PROJECT_SOURCE_DIR}/scripts
  DESTINATION ./
  COMPONENT Devel EXCLUDE_FROM_ALL
)

install(EXPORT QtCreator
  DESTINATION "lib/cmake/QtCreator"
  COMPONENT Devel EXCLUDE_FROM_ALL
  NAMESPACE QtCreator::
  FILE QtCreatorTargets.cmake
)

file(WRITE ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake "
include(CMakeFindDependencyMacro)
find_dependency(Qt5
  COMPONENTS Concurrent Core Network PrintSupport Qml Quick QuickWidgets Sql REQUIRED
)

if (NOT IDE_VERSION)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorIDEBranding.cmake)
endif()

if (NOT DEFINED add_qtc_plugin)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorAPI.cmake)
endif()

if (NOT TARGET QtCreator::Core)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTargets.cmake)
endif()
")

# Local build export
export(EXPORT QtCreator
  NAMESPACE QtCreator::
  FILE ${CMAKE_BINARY_DIR}/cmake/QtCreatorTargets.cmake)

file(COPY
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorIDEBranding.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
  DESTINATION ${CMAKE_BINARY_DIR}/cmake
)

# Devel package install
install(
  FILES
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorIDEBranding.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
    ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake
  DESTINATION lib/cmake/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
)

=== tests/CMakeLists.txt ===
add_subdirectory(auto)
# add_subdirectory(manual)
# add_subdirectory(tools)
add_subdirectory(unit)

=== share/qtcreator/CMakeLists.txt ===
set(template_directories cplusplus debugger glsl modeleditor qml qmldesigner
  qmlicons qml-type-descriptions schemes scripts snippets styles templates themes welcomescreen)

add_custom_target(copy_share_to_builddir ALL
  COMMENT Copy files into build directory
  VERBATIM
)

foreach(dir IN ITEMS ${template_directories})
  add_custom_command(TARGET copy_share_to_builddir POST_BUILD
    COMMAND "${CMAKE_COMMAND}" -E copy_directory "${dir}"
      "${PROJECT_BINARY_DIR}/${IDE_DATA_PATH}/${dir}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    COMMENT Copy files into build directory
    VERBATIM
  )
endforeach()

install(DIRECTORY ${template_directories} DESTINATION "${IDE_DATA_PATH}")
install(
  FILES indexer_preincludes/qglobal.h indexer_preincludes/windows.h
  DESTINATION "${IDE_DATA_PATH}/indexer_preincludes"
)

add_subdirectory(translations)

=== src/app/CMakeLists.txt ===
configure_file(app_version.h.cmakein app_version.h ESCAPE_QUOTES)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/app_version.h
  DESTINATION include/src/app
  COMPONENT Devel EXCLUDE_FROM_ALL
)

add_qtc_executable(qtcreator
  DEFINES IDE_LIBRARY_BASENAME=\"${IDE_LIBRARY_BASE_PATH}\"
  DEPENDS Aggregation ExtensionSystem Qt5::Core Qt5::Widgets Utils shared_qtsingleapplication app_version
  SOURCES
    main.cpp
    ../tools/qtcreatorcrashhandler/crashhandlersetup.cpp ../tools/qtcreatorcrashhandler/crashhandlersetup.h
  PROPERTIES
    WIN32_EXECUTABLE ON
    MACOSX_BUNDLE ON
    OUTPUT_NAME "${IDE_APP_TARGET}"
  DESTINATION "${IDE_APP_PATH}"
)

if (WIN32)
  set(RC_APPLICATION_NAME "${IDE_DISPLAY_NAME}")
  set(RC_VERSION "${IDE_VERSION}.0")
  set(RC_VERSION_STRING "${IDE_VERSION_DISPLAY}")
  set(RC_COPYRIGHT "2008-${IDE_COPYRIGHT_YEAR} The Qt Company Ltd")

  string(REPLACE " " "\\x20" RC_APPLICATION_NAME "${RC_APPLICATION_NAME}")
  string(REPLACE " " "\\x20" RC_COPYRIGHT "${RC_COPYRIGHT}")
  string(REPLACE "." "," RC_VERSION "${RC_VERSION}")

  target_compile_definitions(qtcreator PRIVATE
    RC_APPLICATION_NAME=${RC_APPLICATION_NAME}
    RC_VERSION=${RC_VERSION}
    RC_VERSION_STRING=${RC_VERSION_STRING}
    RC_COPYRIGHT=${RC_COPYRIGHT}
  )

  target_sources(qtcreator PRIVATE qtcreator.rc)
endif()

if (APPLE)
  set_target_properties(qtcreator PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/app-Info.plist"
  )
  # icon
  add_custom_command(
    OUTPUT qtcreator.icns qtcreator-project.icns
    COMMAND
      xcrun actool --app-icon qtcreator --output-partial-info-plist "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.Info.plist"
      --platform macosx --minimum-deployment-target 10.7 --compile "${CMAKE_CURRENT_BINARY_DIR}"
      "${CMAKE_CURRENT_SOURCE_DIR}/qtcreator.xcassets"
      > /dev/null
    BYPRODUCTS qtcreator.Info.plist
    VERBATIM
  )
  target_sources(qtcreator
    PRIVATE
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns"
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns"
  )
  set_source_files_properties(
    "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns"
    "${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns"
    PROPERTIES
      MACOSX_PACKAGE_LOCATION "Resources"
  )
endif()

=== src/tools/CMakeLists.txt ===
add_subdirectory(3rdparty)
add_subdirectory(buildoutputparser)
if (NOT Clang_FOUND)
  message(WARNING "Could not find Clang installation - disabling clangbackend.")
else ()
  add_subdirectory(clangbackend)
  add_subdirectory(clangrefactoringbackend)
  add_subdirectory(clangpchmanagerbackend)
endif ()

option(BUILD_CPLUSPLUS_TOOLS "Build CPlusPlus tools" OFF)

function(add_qtc_cpp_tool name)
  add_qtc_executable(${name}
    DEFINES
      PATH_PREPROCESSOR_CONFIG=\"${CMAKE_CURRENT_SOURCE_DIR}/pp-configuration.inc\"
      ${ARGN}
    DEPENDS CPlusPlus Utils Qt5::Widgets
    INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-shared"
      "${CMAKE_CURRENT_SOURCE_DIR}/${name}"
    SOURCES
      cplusplus-shared/utils.cpp
      "${name}/${name}.cpp"
  )
endfunction()

if (BUILD_CPLUSPLUS_TOOLS)
  add_qtc_cpp_tool(cplusplus-ast2png "")
  add_qtc_cpp_tool(cplusplus-frontend "")
  add_qtc_cpp_tool(cplusplus-mkvisitor PATH_AST_H=\"${CMAKE_CURRENT_SOURCE_DIR}/../../libs/3rdparty/cplusplus/AST.h\")
  add_qtc_cpp_tool(cplusplus-update-frontend PATH_CPP_FRONTEND=\"${CMAKE_CURRENT_SOURCE_DIR}/../../libs/3rdparty/cplusplus\" PATH_DUMPERS_FILE=\"${CMAKE_CURRENT_SOURCE_DIR}/../cplusplus-ast2png/dumpers.inc\")
endif()

if (APPLE)
  add_subdirectory(iostool)
endif()

add_subdirectory(qml2puppet)
add_subdirectory(qtcdebugger) ## windows only
# add_subdirectory(qtcrashhandler)
add_subdirectory(qtc-askpass)
add_subdirectory(qtcreatorcrashhandler)
# add_subdirectory(qtcreatorwidgets) ## qbs does not build this either
add_subdirectory(qtpromaker)
# add_subdirectory(screenshotcropper) ## qbs does not build this either
add_subdirectory(sdktool)
add_subdirectory(valgrindfake)
add_subdirectory(wininterrupt) ## windows only
add_subdirectory(winrtdebughelper) ## windows only

=== share/qtcreator/translations/CMakeLists.txt ===
set(languages cs da de fr ja pl ru sl uk zh_CN zh_TW)
set(bad_languages hu) # Fix these before including them in languages!

find_package(PythonInterp)

set(json_wizards_h "")
set(custom_wizards_h "")
set(externaltools_h "")
set(snippets_h "")

if (NOT PYTHONINTERP_FOUND OR NOT PYTHON_VERSION_STRING VERSION_GREATER_EQUAL "3.0.0")
  message(WARNING "No python3 interpreter found, skipping extraction of data from XML and JSON files.\n *** Please pass -DPYTHON_EXECUTABLE=/path/to/python3 to cmake.")
else()
  set(json_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/jsonwizards_tr.h")
  add_custom_command(OUTPUT "${json_wizards_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-jsonwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${json_wizards_h}"
    COMMENT Generate translation data from JSON wizards
    VERBATIM)

  set(custom_wizards_h "${CMAKE_CURRENT_BINARY_DIR}/customwizards_tr.h")
  add_custom_command(OUTPUT "${custom_wizards_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-customwizards.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/templates/wizards" "${custom_wizards_h}"
    COMMENT Generate translation data from XML wizards
    VERBATIM)

  set(externaltools_h "${CMAKE_CURRENT_BINARY_DIR}/externaltools_tr.h")
  add_custom_command(OUTPUT "${externaltools_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-externaltools.py"
      "${PROJECT_SOURCE_DIR}/src/share/qtcreator/externaltools" "${externaltools_h}"
    COMMENT Generate translation data from external tools definitions
    VERBATIM)

  set(snippets_h "${CMAKE_CURRENT_BINARY_DIR}/snippets_tr.h")
  add_custom_command(OUTPUT "${snippets_h}"
    COMMAND "${PYTHON_EXECUTABLE}"
      "${CMAKE_CURRENT_SOURCE_DIR}/extract-snippets.py"
      "${PROJECT_SOURCE_DIR}/share/qtcreator/snippets" "${snippets_h}"
    COMMENT Generate translation data from snippets definitions
    VERBATIM)
endif()

function(_extract_ts_data_from_targets outprefix)
  set(_sources "")
  set(_includes "")

  set(_targets "${ARGN}")
  list(REMOVE_DUPLICATES _targets)

  foreach(t IN ITEMS ${_targets})
    if (TARGET "${t}")
      get_target_property(_skip_translation "${t}" QT_SKIP_TRANSLATION)
      get_target_property(_source_dir "${t}" SOURCE_DIR)
      get_target_property(_interface_include_dirs "${t}" INTERFACE_INCLUDE_DIRECTORIES)
      get_target_property(_include_dirs "${t}" INCLUDE_DIRECTORIES)
      get_target_property(_source_files "${t}" SOURCES)
      get_target_property(_extra_translations "${t}" QT_EXTRA_TRANSLATIONS)

      if (NOT _skip_translation)
        if(_include_dirs)
          list(APPEND _includes ${_include_dirs})
        endif()

        if(_interface_include_dirs)
          list(APPEND _interface_includes ${_include_dirs})
        endif()

        set(_target_sources "")
        if(_source_files)
          list(APPEND _target_sources ${_source_files})
        endif()
        if(_extra_translations)
          list(APPEND _target_sources ${_extra_translations})
        endif()
        foreach(s IN ITEMS ${_target_sources})
          get_filename_component(_abs_source "${s}" ABSOLUTE BASE_DIR "${_source_dir}")
          list(APPEND _sources "${_abs_source}")
        endforeach()
      endif()
    endif()
  endforeach()

  set("${outprefix}_sources" "${_sources}" PARENT_SCOPE)
  set("${outprefix}_includes" "${_includes}" PARENT_SCOPE)
endfunction()

function(_create_ts_custom_target name)
  cmake_parse_arguments(_arg "" "FILE_PREFIX;TS_TARGET_PREFIX" "LANGUAGES;SOURCES;INCLUDES" ${ARGN})
  if (_arg_UNPARSED_ARGUMENTS)
    message(FATAL_ERROR "Invalid parameters to _create_ts_custom_target: ${_arg_UNPARSED_ARGUMENTS}.")
  endif()

  if (NOT _arg_TS_TARGET_PREFIX)
    set(_arg_TS_TARGET_PREFIX "ts_")
  endif()

  set(ts_languages ${_arg_LANGUAGES})
  if (NOT ts_languages)
    set(ts_languages "${name}")
  endif()

  foreach(l IN ITEMS ${ts_languages})
    list(APPEND ts_files "${CMAKE_CURRENT_SOURCE_DIR}/${_arg_FILE_PREFIX}_${l}.ts")
  endforeach()

  set(_sources "${_arg_SOURCES}")
  list(SORT _sources)

  set(_includes "${_arg_INCLUDES}")

  list(REMOVE_DUPLICATES _sources)
  list(REMOVE_DUPLICATES _includes)

  list(REMOVE_ITEM _sources "")
  list(REMOVE_ITEM _includes "")

  set(_prepended_includes)
  foreach(include IN LISTS _includes)
    list(APPEND _prepended_includes "-I${include}")
  endforeach()
  set(_includes "${_prepended_includes}")

  string(REPLACE ";" "\n" _sources_str "${_sources}")
  string(REPLACE ";" "\n" _includes_str "${_includes}")

  set(ts_file_list "${CMAKE_CURRENT_BINARY_DIR}/ts_${name}.lst")
  file(WRITE "${ts_file_list}" "${_sources_str}\n${_includes_str}\n")

  add_custom_target("${_arg_TS_TARGET_PREFIX}${name}"
    COMMAND Qt5::lupdate -locations relative -no-ui-lines -no-sort "@${ts_file_list}" -ts ${ts_files}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    COMMENT "Generate .ts files"
    DEPENDS ${_sources}
    VERBATIM)
endfunction()

function(add_translation_targets file_prefix)
  if (NOT TARGET Qt5::lrelease)
    # No Qt translation tools were found: Skip this directory
    message(WARNING "No Qt translation tools found, skipping translation targets. Add find_package(Qt5 COMPONENTS LinguistTools) to CMake to enable.")
    return()
  endif()

  cmake_parse_arguments(_arg ""
    "OUTPUT_DIRECTORY;INSTALL_DESTINATION;TS_TARGET_PREFIX;QM_TARGET_PREFIX;ALL_QM_TARGET"
    "LANGUAGES;TARGETS;SOURCES;INCLUDES" ${ARGN})
  if (_arg_UNPARSED_ARGUMENTS)
    message(FATAL_ERROR "Invalid parameters to add_translation_targets: ${_arg_UNPARSED_ARGUMENTS}.")
  endif()

  if (NOT _arg_TS_TARGET_PREFIX)
    set(_arg_TS_TARGET_PREFIX "ts_")
  endif()

  if (NOT _arg_QM_TARGET_PREFIX)
    set(_arg_QM_TARGET_PREFIX "generate_qm_file_")
  endif()

  if (NOT _arg_ALL_QM_TARGET)
    set(_arg_ALL_QM_TARGET "generate_qm_files")
  endif()

  if (NOT _arg_OUTPUT_DIRECTORY)
    set(_arg_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  endif()

  if (NOT _arg_INSTALL_DESTINATION)
    message(FATAL_ERROR "Please provide a INSTALL_DESTINATION to add_translation_targets")
  endif()

  _extract_ts_data_from_targets(_to_process "${_arg_TARGETS}")

  _create_ts_custom_target(untranslated
    FILE_PREFIX "${file_prefix}" TS_TARGET_PREFIX "${_arg_TS_TARGET_PREFIX}"
    SOURCES ${_to_process_sources} ${_arg_SOURCES} INCLUDES ${_to_process_includes} ${_arg_INCLUDES})

  if (NOT TARGET "${_arg_ALL_QM_TARGET}")
    add_custom_target("${_arg_ALL_QM_TARGET}" ALL COMMENT "Generate .qm-files")
  endif()

  foreach(l IN ITEMS ${_arg_LANGUAGES})
    set(_ts_file "${CMAKE_CURRENT_SOURCE_DIR}/${file_prefix}_${l}.ts")
    set(_qm_file "${_arg_OUTPUT_DIRECTORY}/${file_prefix}_${l}.qm")

    _create_ts_custom_target("${l}" FILE_PREFIX "${file_prefix}" TS_TARGET_PREFIX "${_arg_TS_TARGET_PREFIX}"
      SOURCES ${_to_process_sources} ${_arg_SOURCES} INCLUDES ${_to_process_includes} ${_arg_INCLUDES})

    add_custom_command(OUTPUT "${_qm_file}"
      COMMAND Qt5::lrelease "${_ts_file}" -qm "${_qm_file}"
      MAIN_DEPENDENCY "${_ts_file}"
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
      COMMENT "Generate .qm file"
      VERBATIM)
    add_custom_target("${_arg_QM_TARGET_PREFIX}${l}" DEPENDS "${_qm_file}")
    install(FILES "${_qm_file}" DESTINATION ${_arg_INSTALL_DESTINATION})

    add_dependencies("${_arg_ALL_QM_TARGET}" "${_arg_QM_TARGET_PREFIX}${l}")
  endforeach()

  _create_ts_custom_target(all LANGUAGES ${_arg_LANGUAGES} FILE_PREFIX "${file_prefix}"
    SOURCES ${_to_process_sources} ${_arg_SOURCES} INCLUDES ${_to_process_includes} ${_arg_INCLUDES})
endfunction()

### collect targets to include in documentation:
add_translation_targets(qtcreator
  LANGUAGES ${languages}
  OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${IDE_DATA_PATH}/translations"
  INSTALL_DESTINATION "${IDE_DATA_PATH}/translations"
  TARGETS "${__QTC_LIBRARIES}" "${__QTC_PLUGINS}"
  SOURCES "${json_wizards_h}" "${custom_wizards_h}" "${externaltools_h}" "${snippets_h}")

=== src/libs/clangsupport/CMakeLists.txt ===
set(CLANG_VERSION ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})

add_qtc_library(ClangSupport
  DEPENDS Threads::Threads
  PUBLIC_DEPENDS Utils Sqlite Qt5::Core Qt5::Network
  PUBLIC_DEFINES
    CLANG_VERSION="${CLANG_VERSION}"
    CLANG_RESOURCE_DIR="${LLVM_LIBRARY_DIR}/clang/${CLANG_VERSION}/include"
    CLANG_BINDIR="${LLVM_TOOLS_BINARY_DIR}"
  DEFINES CLANGSUPPORT_BUILD_LIB
  SOURCES
    alivemessage.cpp alivemessage.h
    annotationsmessage.cpp annotationsmessage.h
    baseserverproxy.cpp baseserverproxy.h
    cancelmessage.cpp cancelmessage.h
    clangcodemodelclientinterface.cpp clangcodemodelclientinterface.h
    clangcodemodelclientmessages.h
    clangcodemodelclientproxy.cpp clangcodemodelclientproxy.h
    clangcodemodelconnectionclient.cpp clangcodemodelconnectionclient.h
    clangcodemodelserverinterface.cpp clangcodemodelserverinterface.h
    clangcodemodelservermessages.h
    clangcodemodelserverproxy.cpp clangcodemodelserverproxy.h
    clangpathwatcher.h
    clangpathwatcherinterface.h
    clangpathwatchernotifier.h
    clangrefactoringclientmessages.h
    clangrefactoringmessages.h
    clangrefactoringservermessages.h
    clangsupport_global.h
    clangsupportdebugutils.cpp clangsupportdebugutils.h
    clangsupportexceptions.h
    codecompletion.cpp codecompletion.h
    codecompletionchunk.cpp codecompletionchunk.h
    commandlinebuilder.h
    compilermacro.h
    completionsmessage.cpp completionsmessage.h
    connectionclient.cpp connectionclient.h
    connectionserver.cpp connectionserver.h
    diagnosticcontainer.cpp diagnosticcontainer.h
    directoryandfilepathid.h
    directorypathid.h
    documentschangedmessage.cpp documentschangedmessage.h
    documentsclosedmessage.cpp documentsclosedmessage.h
    documentsopenedmessage.cpp documentsopenedmessage.h
    documentvisibilitychangedmessage.cpp documentvisibilitychangedmessage.h
    dynamicastmatcherdiagnosticcontainer.cpp dynamicastmatcherdiagnosticcontainer.h
    dynamicastmatcherdiagnosticcontextcontainer.cpp dynamicastmatcherdiagnosticcontextcontainer.h
    dynamicastmatcherdiagnosticmessagecontainer.cpp dynamicastmatcherdiagnosticmessagecontainer.h
    dynamicmatcherdiagnostics.h
    echomessage.cpp echomessage.h
    endmessage.cpp endmessage.h
    environment.h
    executeinloop.h
    filecontainer.cpp filecontainer.h
    filecontainerv2.cpp filecontainerv2.h
    filepath.cpp filepath.h
    filepathcache.h
    filepathcaching.cpp filepathcaching.h
    filepathcachingfwd.h
    filepathcachinginterface.h
    filepathexceptions.h
    filepathid.cpp filepathid.h
    filepathstorage.h
    filepathstoragesources.h
    filepathstoragesqlitestatementfactory.h
    filepathview.h
    filestatus.h
    filestatuscache.cpp filestatuscache.h
    filesystem.cpp filesystem.h
    filesysteminterface.h
    fixitcontainer.cpp fixitcontainer.h
    followsymbolmessage.cpp followsymbolmessage.h
    generatedfiles.cpp generatedfiles.h
    generatedfilesinterface.h
    idpaths.h
    includesearchpath.h
    ipcclientinterface.h
    ipcclientprovider.h
    ipcinterface.h
    ipcserverinterface.h
    lineprefixer.cpp lineprefixer.h
    messageenvelop.cpp messageenvelop.h
    modifiedtimechecker.h
    modifiedtimecheckerinterface.h
    nativefilepath.h
    pchmanagerclientinterface.cpp pchmanagerclientinterface.h
    pchmanagerclientproxy.cpp pchmanagerclientproxy.h
    pchmanagerserverinterface.cpp pchmanagerserverinterface.h
    pchmanagerserverproxy.cpp pchmanagerserverproxy.h
    pchpaths.h
    precompiledheadersupdatedmessage.cpp precompiledheadersupdatedmessage.h
    processcreator.cpp processcreator.h
    processexception.cpp processexception.h
    processhandle.h
    processstartedevent.cpp processstartedevent.h
    progresscounter.h
    progressmessage.h
    projectmanagementserverinterface.h
    projectpartartefact.cpp projectpartartefact.h
    projectpartcontainer.cpp projectpartcontainer.h
    projectpartid.h
    projectpartpch.cpp projectpartpch.h
    projectpartsstorage.h
    projectpartsstorageinterface.h
    readmessageblock.cpp readmessageblock.h
    refactoringclientinterface.cpp refactoringclientinterface.h
    refactoringclientproxy.cpp refactoringclientproxy.h
    refactoringdatabaseinitializer.h
    refactoringserverinterface.cpp refactoringserverinterface.h
    refactoringserverproxy.cpp refactoringserverproxy.h
    referencesmessage.cpp referencesmessage.h
    removegeneratedfilesmessage.cpp removegeneratedfilesmessage.h
    removeprojectpartsmessage.h
    requestannotationsmessage.cpp requestannotationsmessage.h
    requestcompletionsmessage.cpp requestcompletionsmessage.h
    requestfollowsymbolmessage.cpp requestfollowsymbolmessage.h
    requestreferencesmessage.cpp requestreferencesmessage.h
    requestsourcerangesanddiagnosticsforquerymessage.cpp requestsourcerangesanddiagnosticsforquerymessage.h
    requestsourcerangesforquerymessage.cpp requestsourcerangesforquerymessage.h
    requesttooltipmessage.cpp requesttooltipmessage.h
    sourceentry.h
    sourcelocationcontainer.cpp sourcelocationcontainer.h
    sourcelocationcontainerv2.cpp sourcelocationcontainerv2.h
    sourcelocationscontainer.cpp sourcelocationscontainer.h
    sourcerangecontainer.cpp sourcerangecontainer.h
    sourcerangecontainerv2.cpp sourcerangecontainerv2.h
    sourcerangesanddiagnosticsforquerymessage.cpp sourcerangesanddiagnosticsforquerymessage.h
    sourcerangescontainer.cpp sourcerangescontainer.h
    sourcerangesforquerymessage.cpp sourcerangesforquerymessage.h
    sourcerangewithtextcontainer.cpp sourcerangewithtextcontainer.h
    stringcache.h
    stringcachealgorithms.h
    stringcachefwd.h
    tokeninfocontainer.cpp tokeninfocontainer.h
    tooltipinfo.cpp tooltipinfo.h
    tooltipmessage.cpp tooltipmessage.h
    unsavedfilesremovedmessage.cpp unsavedfilesremovedmessage.h
    unsavedfilesupdatedmessage.cpp unsavedfilesupdatedmessage.h
    updategeneratedfilesmessage.cpp updategeneratedfilesmessage.h
    updateprojectpartsmessage.cpp updateprojectpartsmessage.h
    writemessageblock.cpp writemessageblock.h
)

=== src/libs/extensionsystem/CMakeLists.txt ===
add_qtc_library(ExtensionSystem
  DEPENDS Aggregation Utils
  PUBLIC_DEPENDS Qt5::Core Qt5::Widgets
  SOURCES
    extensionsystem_global.h
    invoker.cpp invoker.h
    iplugin.cpp iplugin.h iplugin_p.h
    optionsparser.cpp optionsparser.h
    plugindetailsview.cpp plugindetailsview.h plugindetailsview.ui
    pluginerroroverview.cpp pluginerroroverview.h pluginerroroverview.ui
    pluginerrorview.cpp pluginerrorview.h pluginerrorview.ui
    pluginmanager.cpp pluginmanager.h pluginmanager_p.h
    pluginspec.cpp pluginspec.h pluginspec_p.h
    pluginview.cpp pluginview.h
  EXPLICIT_MOC
    pluginmanager.h
    pluginmanager_p.h
  SKIP_AUTOMOC pluginmanager.cpp
)

=== src/libs/modelinglib/CMakeLists.txt ===
add_qtc_library(Modeling
  DEFINES MODELING_LIBRARY
  DEPENDS Qt5::Widgets Utils
  PUBLIC_DEPENDS OptionalSvg
  INCLUDES qtserialization/inc
  SOURCES
    qmt/config/configcontroller.cpp qmt/config/configcontroller.h
    qmt/config/sourcepos.cpp qmt/config/sourcepos.h
    qmt/config/stereotypedefinitionparser.cpp qmt/config/stereotypedefinitionparser.h
    qmt/config/stringtextsource.cpp qmt/config/stringtextsource.h
    qmt/config/textscanner.cpp qmt/config/textscanner.h
    qmt/config/textsource.h
    qmt/config/token.cpp qmt/config/token.h
    qmt/controller/container.h
    qmt/controller/namecontroller.cpp qmt/controller/namecontroller.h
    qmt/controller/references.h
    qmt/controller/selection.cpp qmt/controller/selection.h
    qmt/controller/undocommand.cpp qmt/controller/undocommand.h
    qmt/controller/undocontroller.cpp qmt/controller/undocontroller.h
    qmt/diagram_controller/dclonevisitor.cpp qmt/diagram_controller/dclonevisitor.h
    qmt/diagram_controller/dcontainer.h
    qmt/diagram_controller/dfactory.cpp qmt/diagram_controller/dfactory.h
    qmt/diagram_controller/dflatassignmentvisitor.cpp qmt/diagram_controller/dflatassignmentvisitor.h
    qmt/diagram_controller/diagramcontroller.cpp qmt/diagram_controller/diagramcontroller.h
    qmt/diagram_controller/dreferences.h
    qmt/diagram_controller/dselection.h
    qmt/diagram_controller/dupdatevisitor.cpp qmt/diagram_controller/dupdatevisitor.h
    qmt/diagram_controller/dvoidvisitor.cpp qmt/diagram_controller/dvoidvisitor.h
    qmt/diagram/dannotation.cpp qmt/diagram/dannotation.h
    qmt/diagram/dassociation.cpp qmt/diagram/dassociation.h
    qmt/diagram/dboundary.cpp qmt/diagram/dboundary.h
    qmt/diagram/dclass.cpp qmt/diagram/dclass.h
    qmt/diagram/dcomponent.cpp qmt/diagram/dcomponent.h
    qmt/diagram/dconnection.cpp qmt/diagram/dconnection.h
    qmt/diagram/dconstvisitor.h
    qmt/diagram/ddependency.cpp qmt/diagram/ddependency.h
    qmt/diagram/ddiagram.cpp qmt/diagram/ddiagram.h
    qmt/diagram/delement.cpp qmt/diagram/delement.h
    qmt/diagram/dinheritance.cpp qmt/diagram/dinheritance.h
    qmt/diagram/ditem.cpp qmt/diagram/ditem.h
    qmt/diagram/dobject.cpp qmt/diagram/dobject.h
    qmt/diagram/dpackage.cpp qmt/diagram/dpackage.h
    qmt/diagram/drelation.cpp qmt/diagram/drelation.h
    qmt/diagram/dswimlane.cpp qmt/diagram/dswimlane.h
    qmt/diagram/dvisitor.h
    qmt/diagram_scene/capabilities/alignable.h
    qmt/diagram_scene/capabilities/editable.h
    qmt/diagram_scene/capabilities/intersectionable.h
    qmt/diagram_scene/capabilities/latchable.h
    qmt/diagram_scene/capabilities/moveable.h
    qmt/diagram_scene/capabilities/relationable.h
    qmt/diagram_scene/capabilities/resizable.h
    qmt/diagram_scene/capabilities/selectable.h
    qmt/diagram_scene/capabilities/windable.h
    qmt/diagram_scene/diagramgraphicsscene.cpp qmt/diagram_scene/diagramgraphicsscene.h
    qmt/diagram_scene/diagramsceneconstants.h
    qmt/diagram_scene/diagramscenemodel.cpp qmt/diagram_scene/diagramscenemodel.h
    qmt/diagram_scene/diagramscenemodelitemvisitors.cpp qmt/diagram_scene/diagramscenemodelitemvisitors.h
    qmt/diagram_scene/items/annotationitem.cpp qmt/diagram_scene/items/annotationitem.h
    qmt/diagram_scene/items/associationitem.cpp qmt/diagram_scene/items/associationitem.h
    qmt/diagram_scene/items/boundaryitem.cpp qmt/diagram_scene/items/boundaryitem.h
    qmt/diagram_scene/items/classitem.cpp qmt/diagram_scene/items/classitem.h
    qmt/diagram_scene/items/componentitem.cpp qmt/diagram_scene/items/componentitem.h
    qmt/diagram_scene/items/connectionitem.cpp qmt/diagram_scene/items/connectionitem.h
    qmt/diagram_scene/items/diagramitem.cpp qmt/diagram_scene/items/diagramitem.h
    qmt/diagram_scene/items/itemitem.cpp qmt/diagram_scene/items/itemitem.h
    qmt/diagram_scene/items/objectitem.cpp qmt/diagram_scene/items/objectitem.h
    qmt/diagram_scene/items/packageitem.cpp qmt/diagram_scene/items/packageitem.h
    qmt/diagram_scene/items/relationitem.cpp qmt/diagram_scene/items/relationitem.h
    qmt/diagram_scene/items/stereotypedisplayvisitor.cpp qmt/diagram_scene/items/stereotypedisplayvisitor.h
    qmt/diagram_scene/items/swimlaneitem.cpp qmt/diagram_scene/items/swimlaneitem.h
    qmt/diagram_scene/latchcontroller.cpp qmt/diagram_scene/latchcontroller.h
    qmt/diagram_scene/parts/alignbuttonsitem.cpp qmt/diagram_scene/parts/alignbuttonsitem.h
    qmt/diagram_scene/parts/alignlineitem.cpp qmt/diagram_scene/parts/alignlineitem.h
    qmt/diagram_scene/parts/arrowitem.cpp qmt/diagram_scene/parts/arrowitem.h
    qmt/diagram_scene/parts/contextlabelitem.cpp qmt/diagram_scene/parts/contextlabelitem.h
    qmt/diagram_scene/parts/customiconitem.cpp qmt/diagram_scene/parts/customiconitem.h
    qmt/diagram_scene/parts/editabletextitem.cpp qmt/diagram_scene/parts/editabletextitem.h
    qmt/diagram_scene/parts/pathselectionitem.cpp qmt/diagram_scene/parts/pathselectionitem.h
    qmt/diagram_scene/parts/rectangularselectionitem.cpp qmt/diagram_scene/parts/rectangularselectionitem.h
    qmt/diagram_scene/parts/relationstarter.cpp qmt/diagram_scene/parts/relationstarter.h
    qmt/diagram_scene/parts/stereotypesitem.cpp qmt/diagram_scene/parts/stereotypesitem.h
    qmt/diagram_scene/parts/templateparameterbox.cpp qmt/diagram_scene/parts/templateparameterbox.h
    qmt/diagram_ui/diagram_mime_types.h
    qmt/diagram_ui/diagramsmanager.cpp qmt/diagram_ui/diagramsmanager.h
    qmt/diagram_ui/diagramsviewinterface.h
    qmt/diagram_ui/sceneinspector.cpp qmt/diagram_ui/sceneinspector.h
    qmt/diagram_widgets_ui/diagramsview.cpp qmt/diagram_widgets_ui/diagramsview.h
    qmt/diagram_widgets_ui/diagramview.cpp qmt/diagram_widgets_ui/diagramview.h
    qmt/diagram_widgets_ui/stackeddiagramsview.cpp qmt/diagram_widgets_ui/stackeddiagramsview.h
    qmt/document_controller/documentcontroller.cpp qmt/document_controller/documentcontroller.h
    qmt/infrastructure/contextmenuaction.cpp qmt/infrastructure/contextmenuaction.h
    qmt/infrastructure/exceptions.cpp qmt/infrastructure/exceptions.h
    qmt/infrastructure/geometryutilities.cpp qmt/infrastructure/geometryutilities.h
    qmt/infrastructure/handle.h
    qmt/infrastructure/handles.h
    qmt/infrastructure/ioexceptions.cpp qmt/infrastructure/ioexceptions.h
    qmt/infrastructure/qcompressedfile.cpp qmt/infrastructure/qcompressedfile.h
    qmt/infrastructure/qmtassert.h
    qmt/infrastructure/qmt_global.h
    qmt/infrastructure/uid.h
    qmt/model_controller/mchildrenvisitor.cpp qmt/model_controller/mchildrenvisitor.h
    qmt/model_controller/mclonevisitor.cpp qmt/model_controller/mclonevisitor.h
    qmt/model_controller/mcontainer.h
    qmt/model_controller/mflatassignmentvisitor.cpp qmt/model_controller/mflatassignmentvisitor.h
    qmt/model_controller/modelcontroller.cpp qmt/model_controller/modelcontroller.h
    qmt/model_controller/mreferences.h
    qmt/model_controller/mselection.h
    qmt/model_controller/mvoidvisitor.cpp qmt/model_controller/mvoidvisitor.h
    qmt/model/massociation.cpp qmt/model/massociation.h
    qmt/model/mcanvasdiagram.cpp qmt/model/mcanvasdiagram.h
    qmt/model/mclass.cpp qmt/model/mclass.h
    qmt/model/mclassmember.cpp qmt/model/mclassmember.h
    qmt/model/mcomponent.cpp qmt/model/mcomponent.h
    qmt/model/mconnection.cpp qmt/model/mconnection.h
    qmt/model/mconstvisitor.h
    qmt/model/mdependency.cpp qmt/model/mdependency.h
    qmt/model/mdiagram.cpp qmt/model/mdiagram.h
    qmt/model/melement.cpp qmt/model/melement.h
    qmt/model/minheritance.cpp qmt/model/minheritance.h
    qmt/model/mitem.cpp qmt/model/mitem.h
    qmt/model/mobject.cpp qmt/model/mobject.h
    qmt/model/mpackage.cpp qmt/model/mpackage.h
    qmt/model/mrelation.cpp qmt/model/mrelation.h
    qmt/model/msourceexpansion.cpp qmt/model/msourceexpansion.h
    qmt/model/mvisitor.h
    qmt/model_ui/modeltreeviewinterface.h
    qmt/model_ui/sortedtreemodel.cpp qmt/model_ui/sortedtreemodel.h
    qmt/model_ui/stereotypescontroller.cpp qmt/model_ui/stereotypescontroller.h
    qmt/model_ui/treemodel.cpp qmt/model_ui/treemodel.h
    qmt/model_ui/treemodelmanager.cpp qmt/model_ui/treemodelmanager.h
    qmt/model_widgets_ui/classmembersedit.cpp qmt/model_widgets_ui/classmembersedit.h
    qmt/model_widgets_ui/modeltreeview.cpp qmt/model_widgets_ui/modeltreeview.h
    qmt/model_widgets_ui/palettebox.cpp qmt/model_widgets_ui/palettebox.h
    qmt/model_widgets_ui/propertiesview.cpp qmt/model_widgets_ui/propertiesview.h
    qmt/model_widgets_ui/propertiesviewmview.cpp qmt/model_widgets_ui/propertiesviewmview.h
    qmt/project_controller/projectcontroller.cpp qmt/project_controller/projectcontroller.h
    qmt/project/project.cpp qmt/project/project.h
    qmt/resources/resources.qrc
    qmt/serializer/diagramserializer.cpp qmt/serializer/diagramserializer.h
    qmt/serializer/infrastructureserializer.cpp qmt/serializer/infrastructureserializer.h
    qmt/serializer/modelserializer.cpp qmt/serializer/modelserializer.h
    qmt/serializer/projectserializer.cpp qmt/serializer/projectserializer.h
    qmt/stereotype/customrelation.cpp qmt/stereotype/customrelation.h
    qmt/stereotype/iconshape.cpp qmt/stereotype/iconshape.h
    qmt/stereotype/shape.h
    qmt/stereotype/shapepaintvisitor.cpp qmt/stereotype/shapepaintvisitor.h
    qmt/stereotype/shapes.cpp qmt/stereotype/shapes.h
    qmt/stereotype/shapevalue.cpp qmt/stereotype/shapevalue.h
    qmt/stereotype/shapevisitor.h
    qmt/stereotype/stereotypecontroller.cpp qmt/stereotype/stereotypecontroller.h
    qmt/stereotype/stereotypeicon.cpp qmt/stereotype/stereotypeicon.h
    qmt/stereotype/toolbar.cpp qmt/stereotype/toolbar.h
    qmt/style/defaultstyle.cpp
    qmt/style/defaultstyleengine.cpp qmt/style/defaultstyleengine.h
    qmt/style/defaultstyle.h
    qmt/style/objectvisuals.cpp qmt/style/objectvisuals.h
    qmt/style/relationstarterstyle.cpp qmt/style/relationstarterstyle.h
    qmt/style/stylecontroller.cpp qmt/style/stylecontroller.h
    qmt/style/style.cpp
    qmt/style/styledobject.cpp qmt/style/styledobject.h
    qmt/style/styledrelation.cpp qmt/style/styledrelation.h
    qmt/style/styleengine.h
    qmt/style/style.h
    qmt/tasks/alignonrastervisitor.cpp qmt/tasks/alignonrastervisitor.h
    qmt/tasks/diagramscenecontroller.cpp qmt/tasks/diagramscenecontroller.h
    qmt/tasks/finddiagramvisitor.cpp qmt/tasks/finddiagramvisitor.h
    qmt/tasks/findrootdiagramvisitor.cpp qmt/tasks/findrootdiagramvisitor.h
    qmt/tasks/ielementtasks.h
    qmt/tasks/isceneinspector.h
    qmt/tasks/voidelementtasks.cpp qmt/tasks/voidelementtasks.h
    qstringparser/qstringparser.cpp qstringparser/qstringparser.h
    qtserialization/inc/qark/access.h
    qtserialization/inc/qark/archivebasics.h
    qtserialization/inc/qark/attribute.h
    qtserialization/inc/qark/baseclass.h
    qtserialization/inc/qark/flag.h
    qtserialization/inc/qark/friend_access.h
    qtserialization/inc/qark/impl/loadingrefmap.h
    qtserialization/inc/qark/impl/objectid.h
    qtserialization/inc/qark/impl/savingrefmap.h
    qtserialization/inc/qark/parameters.h
    qtserialization/inc/qark/qxmlinarchive.h
    qtserialization/inc/qark/qxmloutarchive.h
    qtserialization/inc/qark/reference.h
    qtserialization/inc/qark/serialize_basic.h
    qtserialization/inc/qark/serialize_container.h
    qtserialization/inc/qark/serialize_enum.h
    qtserialization/inc/qark/serialize.h
    qtserialization/inc/qark/serialize_pointer.h
    qtserialization/inc/qark/tag.h
    qtserialization/inc/qark/typeregistry.h
    qtserialization/src/flag.cpp
    qtserialization/src/savingrefmap.cpp
)

=== src/libs/qmleditorwidgets/CMakeLists.txt ===
add_qtc_library(QmlEditorWidgets
  DEPENDS qmljs Utils Qt5::Widgets
  SOURCES
    colorbox.cpp colorbox.h
    colorbutton.cpp colorbutton.h
    contextpanetext.ui
    contextpanetextwidget.cpp contextpanetextwidget.h
    contextpanewidget.cpp contextpanewidget.h
    contextpanewidgetborderimage.ui
    contextpanewidgetimage.cpp contextpanewidgetimage.h contextpanewidgetimage.ui
    contextpanewidgetrectangle.cpp contextpanewidgetrectangle.h contextpanewidgetrectangle.ui
    customcolordialog.cpp customcolordialog.h
    easingpane/easingcontextpane.cpp easingpane/easingcontextpane.h easingpane/easingcontextpane.ui
    easingpane/easinggraph.cpp easingpane/easinggraph.h
    easingpane/easingpane.qrc
    filewidget.cpp filewidget.h
    fontsizespinbox.cpp fontsizespinbox.h
    gradientline.cpp gradientline.h
    huecontrol.cpp huecontrol.h
    qmleditorwidgets_global.h
    resources.qrc
)

=== debian/changelog ===
qtcreator (4.11.0-2build2) focal; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-8.

 -- Rik Mills <rikmills@kde.org>  Fri, 10 Apr 2020 20:07:23 +0100

qtcreator (4.11.0-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:24:25 +0100

qtcreator (4.11.0-2) unstable; urgency=medium

  * Use Rules-Requires-Root: no.
  * Make qtcreator recommend clang-tidy, used in the Analyze menu.
  * Backport patch to detect compilers supported by ccache, if present.
  * Update Standards-Version to 4.5.0. No changes required.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Wed, 29 Jan 2020 14:48:28 -0300

qtcreator (4.11.0-1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * New upstream release.
  * Update debian/copyright.
  * Refresh patches.
  * Bump Standards-Version to 4.4.1. No changes required.
  * Switch to using debhelper-compat as a build dependency.

  [ Patrick Franz ]
  * Added missing licence-texts in debian/copyright.
  * Fixed licence for metadata.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 14 Dec 2019 12:08:19 -0300

qtcreator (4.10.2-2) unstable; urgency=medium

  * Use the system's KF5SyntaxHighlighting in order to avoid the embedded
    version.
  * Improve debian/copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Mon, 02 Dec 2019 22:55:36 -0300

qtcreator (4.10.2-1) unstable; urgency=medium

  * New upstream release.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 19 Nov 2019 19:28:14 -0300

qtcreator (4.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove ClangFormat-improve-the-message-the-users-see.patch, applied
    upstream.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 08 Oct 2019 22:52:53 -0300

qtcreator (4.10.0-2) unstable; urgency=medium

  * Add ClangFormat-improve-the-message-the-users-see.patch. In this way our
    users can know why the functionality is not there. We will surely not ask
    clang maintainers to patch it with a non-approved patch. This can be
    reconsidered if the patch gets accepted upstream. This is related to
    Debian bug #919860.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 12 Sep 2019 10:41:59 -0300

qtcreator (4.10.0-1) unstable; urgency=medium

  * New upstream release.
  * New changelog entry.
  * Refresh patches dealing with the clazy plugin.
  * Bump debhelper compatibility to 12.
  * Remove now useless lintian overrides.
  * Extend qtcreator-doc long description.
  * Bump Standards-Version to 4.4.0, no changes required.
  * Momentarily disable always_autotect_qt_versions patch, the code has
    changed and we need to check if it's really needed.
  * Switch to LLVM/Clang 8, as required by the source.
  * Force using qmake as build system. We now also hace CMake support. We
    should switch to it as soon as it's considered stable enough.
  * Refresh debian/copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 08 Sep 2019 12:41:07 -0300

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Jeremy Lainé <jeremy.laine@m4x.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Simon Quigley <tsimonq2@debian.org>
Build-Depends: debhelper-compat (= 12),
               libbotan-2-dev,
               libclang-8-dev,
               libicu-dev,
               libjs-jquery,
               libkf5syntaxhighlighting-dev,
               libqt5opengl5-dev (>= 5.6.2~),
               libqt5serialport5-dev,
               libqt5sql5-sqlite (>= 5.6.2~),
               libqt5webkit5-dev (>= 5.6.2~),
               libqt5x11extras5-dev (>= 5.6.2~),
               llvm-8-dev,
               pkg-config,
               qbs-dev (>= 1.12~),
               qml-module-qtquick-controls (>= 5.6.2~),
               qml-module-qtquick2 (>= 5.6.2~),
               qtbase5-dev (>= 5.6.2~),
               qtbase5-private-dev (>= 5.6.2~),
               qtdeclarative5-dev (>= 5.6.2~),
               qtdeclarative5-private-dev (>= 5.6.2~),
               qtscript5-dev (>= 5.6.2~),
               qttools5-dev (>= 5.6.2~),
               qttools5-dev-tools (>= 5.6.2~),
               qttools5-private-dev (>= 5.6.2~),
               qtxmlpatterns5-dev-tools (>= 5.6.2~),
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: libqt5sql5-sqlite,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls (>= 5.5.0~),
         qml-module-qtquick2 (>= 5.5.0~),
         qtchooser,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang,
            clang-tidy,
            gdb,
            make,
            qmlscene,
            qt5-doc,
            qt5-qmltooling-plugins,
            qtbase5-dev-tools,
            qtcreator-doc,
            qtdeclarative5-dev-tools,
            qttools5-dev-tools,
            qttranslations5-l10n,
            qtxmlpatterns5-dev-tools,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, kate-data, subversion, valgrind
Breaks: qtcreator-data (<< 4.5.2-2~)
Replaces: qtcreator-data (<< 4.5.2-2~)
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: qt5-doc
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QT_SELECT := qt5
export LLVM_INSTALL_DIR := "/usr/lib/llvm-8"

# Upstream changelog
upstream_changes := $(wildcard dist/changes-*)

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=qmake -- \
		-recursive \
		QBS_INSTALL_DIR=/usr \
		USE_SYSTEM_BOTAN=1 \
		LLVM_INSTALL_DIR="$(LLVM_INSTALL_DIR)" \
		KSYNTAXHIGHLIGHTING_LIB_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" \
		CONFIG+="disable_external_rpath use_system_botan" \
		$(CURDIR) IDE_LIBRARY_BASENAME=lib/$(DEB_HOST_MULTIARCH) IDE_PACKAGE_MODE=1 $(extra_configure_opts)

override_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	dh_auto_build -- qch_docs
endif
	dh_auto_install --destdir=debian/tmp/usr
	dh_auto_build -- install_docs INSTALL_ROOT=$(CURDIR)/debian/tmp/usr

	# Do not install the file, we better symlink it.
	rm -vf debian/tmp/usr/share/qtcreator/debugger/LICENSE.LGPL

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdocs:
	dh_installdocs -pqtcreator-data $(upstream_changes)
	dh_installdocs --remaining-packages

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator:\
	$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/plugins/QtProject

=== debian/watch ===
version=3
opts="repack,compression=xz"
https://download.qt.io/official_releases/qtcreator/([\d\.]*)/([\d\.]*)/qt-creator-opensource-src-([^-]*)\.tar\.xz
